angular.module('beamng.apps')
.directive('pizzaRunStartAngelo234', [function () {
return {
templateUrl: '/ui/modules/apps/pizza_run_start_angelo234/app.html',
replace: true,
restrict: 'EA',
link: function (scope, element, attrs) {
	var settings_file_path = "settings/pizza_run_angelo234/settings.json";
	
	// The current overlay screen the user is on (default: null)
	scope.overlayScreen = null;
	scope.visible = false;
	
	// parameters user can set
	scope.difficulty = "medium";
	scope.max_distance = 1500;
	scope.traffic_size = 1;
	
	// Read parameter file for last parameters
	bngApi.engineLua("jsonReadFile('" + settings_file_path + "')", function(data) {
		if(data !== undefined){
			scope.difficulty = data.difficulty;
			scope.max_distance = data.max_distance;
			scope.traffic_size = data.traffic_size;
		}
		else{
			// If file doesn't exist create one
		
			// Set traffic_size param from user settings
			bngApi.engineLua("extensions.scenario_pizza_run_angelo234.getDefaultTrafficSize()", (size) => {
				scope.traffic_size = size;
				saveSettingsToFile();
			});		
		}
	});	
	
	// Check if scenario is currently running to set the app visibility
	bngApi.engineLua("extensions.scenario_pizza_run_angelo234.getState() == 'scenario_started'", (visible) => {
		scope.visible = visible;
	});
	
	scope.settingsChanged = function() {
		saveSettingsToFile();
	};
	
	scope.playButtonPressed = function () {
		// Start the scenario!
	
		bngApi.engineLua("extensions.scenario_pizza_run_angelo234.initSettingsAndSelectVehicle('" 
			+ scope.difficulty + "',"
			+ scope.max_distance + ","
			+ scope.traffic_size + ")");
		
		scope.visible = false;
	};
	
	function saveSettingsToFile () {
		// Save current parameters to file
		var data = {}
		data.difficulty = scope.difficulty;
		data.max_distance = scope.max_distance;
		data.traffic_size = scope.traffic_size;
		data = JSON.stringify(data);
	
		bngApi.engineLua("writeFile('" + settings_file_path + "','" + data + "', true)");
	};
	
	// Make sure we clean up after closing the app.
	scope.$on('$destroy', function () {});

},
};
}]);